# $Id: bos_user.rb,v 1.8 2004/09/07 02:22:31 nisi Exp $

require 'digest/md5'

class BosUser
	attr_accessor :prop, :pre_prop
	
	def initialize(user_id,bosm)
		@bosm = bosm
		@bos  = @bosm.bos
		@mydb = @bos.mysql
		@mydo = Rudby::new(@mydb)
		@table_name = "bos_#{$bos_prop[:site_name]}_users"
		setup if !@mydb.list_tables.include?(@table_name)
		if @bosm.session['uid'] == user_id then
			@prop = @mydo.exp({
				:command => "s",
				:target  => @table_name,
				:cols    => set_default,
				:where   => w("user_id"){|a| a == user_id } })[0]
			@pre_prop = @mydo.exp({
				:command => "s",
				:target  => @table_name,
				:cols    => set_default,
				:where   => w("user_id"){|a| a == user_id } })[0]
		else
			if user_id && user_id != "" then
				@pre_prop = @mydo.exp({
					:command => "s",
					:target  => @table_name,
					:cols    => set_default,
					:where   => w("user_id"){|a| a == user_id } })[0]
			end
		end
		if !@pre_prop then
			@pre_prop = set_default
			@newflg = true
		else
			@newflg = false
		end
		@prop = set_default if !@prop
		@address = BosAddress.new(@prop[:address],@mydb) if @prop[:address]
	end

	def setup
		@mydb.query("CREATE TABLE #{@table_name}(" +
			"user_id VARCHAR(20) NOT NULL PRIMARY KEY," +
			"password VARCHAR(32) NOT NULL ," +
			"mail_address VARCHAR(255)," +
			"sex CHAR(1)," +
			"birth DATE," +
			"address INT," +
			"user_level CHAR(1) NOT NULL ," +
			"created DATETIME NOT NULL ," +
			"last_login DATETIME NOT NULL ," +
			"login_count INT NOT NULL );")
		
		su = set_default
		su[:user_id]      = $bos_prop[:user_name]
		su[:password]     = cmd5($bos_prop[:user_address])
		su[:mail_address] = $bos_prop[:user_address]
		su[:user_level]   = 'a'
		@mydo.exp({
			:command => "i",
			:target  => @table_name,
			:cols    => su })
	end
	
	def login(pw)
		return false if !@pre_prop
		if @pre_prop[:password] == cmd5(pw) then
			@prop = @pre_prop
			@pre_prop = @mydo.exp({
				:command => "s",
				:target  => @table_name,
				:cols    => set_default,
				:where   => w("user_id"){|a| a == @prop[:user_id] } })[0]
			@bosm.session['uid'] = @prop[:user_id]
			@prop[:last_login] = DateTime.now
			@prop[:login_count] += 1
			@mydo.exp({
				:command => "u",
				:target  => @table_name,
				:cols    => @prop,
				:where   => w("user_id"){|a| a == @prop[:user_id] } })
		end
		@prop[:user_id]
	end
	
	def logout
		@bosm.session['uid'] = nil
		@prop = set_default
	end

	def set_default
		{
			:user_id      => "",
			:password     => "",
			:mail_address => "",
			:sex          => "",
			:birth        => nil,
			:address      => 0,
			:user_level   => "p",
			:created      => DateTime.now,
			:last_login   => DateTime.now,
			:login_count  => 0 }
	end

	def get_list
		@mydo.exp({
			:command => "s",
			:target  => @table_name,
			:cols    => set_default,
			:order   => "user_id ASC" })
	end

	def commit
		if @pre_prop[:user_id] != "" then
			if @newflg then
#				@prop[:product_id] = @mydo.exp({
				@mydo.exp({
					:command => "i",
					:target  => @table_name,
					:cols    => @pre_prop })
			else
				lct = @mydo.exp({
					:command => "u",
					:target  => @table_name,
					:cols    => @pre_prop,
					:where   => w("user_id"){|a| a == @pre_prop[:user_id]} })
			end
		end
		@pre_prop[:user_id]
	end

	def cmd5(ist)
		Digest::MD5.hexdigest(ist)
	end	

	def self.cmd5(ist)
		Digest::MD5.hexdigest(ist)
	end	

end


class BosAddress

	def initialize(address_id,mydb)
		@mydb = mydb
		@mydo = Rudby::new(@mydb)
		@prop = set_default
		@table_name = "bos_#{$bos_prop[:site_name]}_address"
		@region_table_name = "bos_#{$bos_prop[:site_name]}_region"
		setup if !@mydb.list_tables.include?(@table_name)
		if address_id && address_id != "" then
			@prop = @mydo.exp({
				:command => "s",
				:target  => @table_name,
				:cols    => set_default,
				:where   => "address_id = #{address_id}" })[0]
		end
	end
	
	def setup
		@mydb.query("CREATE TABLE #{@table_name}(" +
			"address_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"registrant VARCHAR(20) ," +
			"postalcode VARCHAR(8) ," +
			"region VARCHAR(10) ," +
			"city VARCHAR(64) ," +
			"address1 VARCHAR(255) ," +
			"address2 VARCHAR(255) ," +
			"lastname VARCHAR(255) ," +
			"firstname VARCHAR(255) ," +
			"tel_no VARCHAR(13) ," +
			"fax_no VARCHAR(13) ," +
			"other_no VARCHAR(13) ," +
			"memo VARCHAR(255) );")
		@mydb.query("CREATE TABLE #{@region_table_name}(" +
			"region_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"region_code VARCHAR(2)," +
			"region_name VARCHAR(10) );")
		
		region_ar = ['̳ƻ','Ŀ','긩','ܾ븩','ĸ','','ʡ縩','븩',
			'ڸ','ϸ','̸','ո','','','㸩','ٻ','',
			'ʡ温','','Ĺ','츩','Ų','θ','Ÿ','츩','',
			'','ʼ˸','ɸ','²λ','Ļ踩','纬','','縩','',
			'縩','','ɲ','θ','ʡ','츩','Ĺ긩','ܸ','ʬ',
			'ܺ긩','縩','츩']

		region_ar.each_with_index{|v,i|
			@mydo.exp({
				:command => "i",
				:target  => @region_table_name,
				:cols    => {
					:region_code => "%02d" % i,
					:region_name => v } })
		}
	end

	def set_default
		{
			:address_id   => 0,
			:registrant   => "",
			:postalcode   => "",
			:region       => "",
			:city         => "",
			:address1     => "",
			:address2     => "",
			:lastname     => "",
			:firstname    => "",
			:tel_no       => "",
			:fax_no       => "",
			:other_no     => "",
			:memo         => "" }
	end

end

